def actionclearonmessage(db, cl, nodeid, newvalues):
    ''' Update status of actionclearonmessage field in issue.
        
	If a new message comes in and the actionclearonmessage
	field is set to true, set the actionclearonmessage field
        to false and the actiondate field to empty.


    '''

    # get debugging info
    if __debug__:
        print "actionclearonmessage.actionclearonmessage[auditor]: triggered"
        print "actionclearonmessage: nodid and newvalues:", nodeid, newvalues

    if newvalues.has_key('actionclearonmessage'):
        # if they set it explicitly, leave it.
        return

    if nodeid == None:
       # on new issue do nothing.
       return

    if not newvalues.has_key('messages') :
       if __debug__:
          print "actionclearonmessage(auditor) exiting. No message."
       return

    current = cl.get(nodeid, 'actionclearonmessage')
    if current != True :
       # if not enabled, return
       if __debug__:
          print "actionclearonmessage(auditor) exiting. actionclearonmessage not true."
       return

    # otherwise clear actiondate and actionclearonmessage
    # don't bother checking to see if a date was assigned.
    # worst case the back end will say we changed from none to none.
    newvalues['actionclearonmessage'] = False
    newvalues['actiondate'] = None

def init(db):
    # fire before changes are made
    db.issue.audit('set', actionclearonmessage)

