def group_not_dependson (db, cl, nodeid, newvalues):
    # make sure that group issues and dependson issues are disjoint sets.
    # otherwise we get the condition that opening the parent issue also
    # opens the resolved issue making it impossible to resolve the group.
    if not (newvalues.has_key("group") or newvalues.has_key("dependson")):
        return

    if __debug__:
        print "disjointdependsongroups.group_not_dependson[auditor]: triggered"
        print "group_not_dependson: nodeid and newvalues:", nodeid, newvalues

    dependees = []
    if newvalues.has_key("dependson"):
	dependees = newvalues["dependson"]
    else:
        if nodeid is not None:
            # an already existing node
	    dependees = cl.get(nodeid, 'dependson')

    if newvalues.has_key("group"):
	groupees = newvalues["group"]
    else:
        if nodeid is not None:
            # an already existing node
	    groupees = cl.get(nodeid, 'group')
    if __debug__:
        print "Dependson: %s - Groups: %s"%(','.join(dependees),','.join(groupees))

    if nodeid in groupees:
        raise ValueError, """
This issue can not group itself. Please remove issue%s
 from the group list."""%nodeid

    if nodeid in dependees:
        raise ValueError, """
This issue can not depend on itself. Please remove issue%s
 from the depends on list."""%nodeid

    if len(groupees) == 0 or len(dependees) == 0:
       return
 
    if len(groupees) < len(dependees):
        conflicts = []
        for issue in groupees:
	    if issue in dependees:
	       conflicts.append(issue)
    else:
        conflicts = []
        for issue in dependees:
	    if issue in groupees:
	       conflicts.append(issue)

    if conflicts:
        raise ValueError, """
The following issue(s) occur in both the dependson and groups relationships.
This is not allowed. Only one relation between this issue and issues(s) %s
 is allowed."""%", ".join(conflicts)

    return

def init(db):
    db.issue.audit('set', group_not_dependson)
    db.issue.audit('create', group_not_dependson)
