# $Id: enforceRepairRole.py,v 1.4 2003/10/05 04:46:44 jrouilla Exp $

def assignedtoMustBeRepair(db, cl, nodeid, newvalues):
    ''' Ensure the assignedto value in newvalues is a user with the Repair
        Permission
    '''
    if __debug__:
        print "enforceRepairRole.assignedtoMustBeRepair[auditor]: triggered"
        print "assignedtoMustBeRepair: nodeid and newvalues:", nodeid, newvalues

    if not newvalues.has_key('assignedto'):
        # don't care
        return

    if newvalues['assignedto'] == None:
        # that's ok.
        return

    # get the userid
    userid = newvalues['assignedto']
    if not db.security.hasPermission('Repair', userid, cl.classname):
        raise ValueError, 'User %s does not have repair role, and can not have tasks assigned to them'%db.user.get(userid, "username")

def init(db):
    db.issue.audit('set', assignedtoMustBeRepair)
    db.issue.audit('create', assignedtoMustBeRepair)


