#$Id: needsreply.py,v 1.3 2003/10/05 04:46:44 jrouilla Exp $

def needsreply(db, cl, nodeid, newvalues):
    ''' Update status of needsreply field in issue.
        
        This will keep the status of the needs reply field up to date
        with changes to the ticket.

	If a new message comes in and the sender is not the assignedto
	person (or person on verynosy (technical list) if no
	assignedto person), set needsreply field to true.

	If there is no assignedto person, set needsreply if changer is
	not on technical list.
	
	If assignedto person (or person on verynosy (technical list) if no
	assignedto person), makes any change to the ticket, unset
	the needsreply.

        If this is a new issue, (nodeid == None) set the needsreply flag
    '''


    # get debugging info
    if __debug__:
        print "needsreply.needsreply[auditor]: triggered"
        print "needsreply: nodeid and newvalues:", nodeid, newvalues

    if newvalues.has_key('needsreply'):
        # if they set it, leave it.
        return

    if nodeid == None:
       # new issue set needsreply
       newvalues['needsreply'] = True
       if __debug__:
          print "needsreply(auditor) newticket setting needsreply"
       return

    # otherwise find the responsible people
    techies = []

    # find the assignedto person
    if newvalues.has_key('assignedto'):
        techies.append(newvalues['assignedto'])

    if techies == []:
      # try looking in issue
      assignedto = cl.get(nodeid, 'assignedto')
      if assignedto != None:
          techies.append(assignedto)

    # if techies is still null, use the people on the verynosy list.
    if techies == []:
        if newvalues.has_key('verynosy'):
            techies.append(newvalues['verynosy'])
	else:
            vn = cl.get(nodeid, 'verynosy')
            if vn != None:
                techies.append(vn)

    if __debug__:
          print "needsreply(auditor) techies: ", techies

    if techies == []:
       # nobody is watching this ticket, so leave the status quo
       return

    if db.getuid() in techies:
        newvalues['needsreply'] = False
    else:
        if newvalues.has_key('messages'):
            newvalues['needsreply'] = True
            # else leave status quo.
    return


def init(db):
    # fire before changes are made
    db.issue.audit('set', needsreply)

# vim: set filetype=python ts=4 sw=4 et si
#SHA: 8b886dd30aaffe232873d1bcdeec179cdaa10aa2
