from roundup import roundupdb

def newissuecopy(db, cl, nodeid, oldvalues):
    ''' Copy a message about new issues to a team address.

	address is determined by looking at queue value.
    '''
    assignedto = cl.get(nodeid, "assignedto")

    # is issue is already assigned, don't annoy people with email
    if assignedto != None:
       return

    whichqueueid = cl.get(nodeid, "queue")
    if whichqueueid == None or (not db.queue.get(whichqueueid, "email")):
        if cl.db.config.NEW_ISSUE_ANNOUNCE_DEFAULT == None:
            return
	else:
	   sendto = cl.db.config.NEW_ISSUE_ANNOUNCE_DEFAULT.split(',')
    else: # there is a queue
        queueemail=db.queue.get(whichqueueid, "email")
	if queueemail.lower() == 'donotsend':
	   # user doesn't want email sent
	   return
        else:
	   sendto = queueemail.split(',')

    # so use all the messages in the create
    change_note = cl.generateCreateNote(nodeid)

    # send a copy to the nosy list
    for msgid in cl.get(nodeid, 'messages'):
        try:
            # note: last arg must be a list
            cl.send_message(nodeid, msgid, change_note, sendto)
        except roundupdb.MessageSendError, message:
            raise roundupdb.DetectorError, message

def init(db):
    db.issue.react('create', newissuecopy)

