#$Id: requestedby.py,v 1.2 2003/05/11 07:18:04 jrouilla Exp $

from roundup import roundupdb, hyperdb

def requestedbyauditor(db, cl, nodeid, newvalues):
    ''' Initializes requestedby to creator of issue.

    '''
    if __debug__:
       print "requestedby.requestedbyauditor[auditor]: triggered"
       print "requestedbyauditor: nodeid, newvalues", nodeid, newvalues


    if not newvalues.has_key('requestedby') and nodeid is None:
       # issue being created. Assign the requestedby to be the creator
       newvalues['requestedby'] = db.getuid()

    if not newvalues.has_key('requestedby'):
       # nothing to do.
       return

    current = {}

    if newvalues.has_key('requestedby') and \
       newvalues['requestedby'] is not None:
       if not newvalues.has_key('nosy'):
          nosy = cl.get(nodeid, 'nosy')
          for value in nosy:
             if not current.has_key(value):
                current[value] = 1
       else:
         # if the nosy list changed in this transaction, init
         # from the new value
         nosy = newvalues.get('nosy', [])
         for value in nosy:
            if not db.hasnode('user', value):
                continue
            if not current.has_key(value):
                current[value] = 1

       # add requestor to nosy list
       propdef = cl.getprops()
       if isinstance(propdef['requestedby'], hyperdb.Link):
           requestedby_ids = [newvalues['requestedby']]
       elif isinstance(propdef['requestedby'], hyperdb.Multilink):
           requestedby_ids = newvalues['requestedby']
       for requestedby_id in requestedby_ids:
           if not current.has_key(requestedby_id):
               current[requestedby_id] = 1

    # that's it, save off the new nosy list
    newvalues['nosy'] = current.keys()

def init(db):
    # fire before changes are made
    db.issue.audit('create', requestedbyauditor)
    db.issue.audit('set', requestedbyauditor)

# vim: set filetype=python ts=4 sw=4 et si
#SHA: 8b886dd30aaffe232873d1bcdeec179cdaa10aa2
