# Make sure that user attempting to change status is permitted to
# change to that status.

def checkstatusperm(db, cl, nodeid, newvalues):
    ''' Check that the user has permission to set the current status
    '''
    if __debug__:
        print "statusperms.checkstatusperm[auditor]: entered"
        print "checkstatusperm: nodeid and newvalues", nodeid, newvalues

    if not newvalues.has_key('status'):
        return

    if nodeid != None:
        current = cl.get(nodeid, 'status')
    else:
        current = None

    new = newvalues['status']

    if new == current:
        # no actual change was done
        return

    if new is None:
        requiredperms = []
    else:
        requiredperms = db.status.get(new, 'requiredpermissions')

    if __debug__:
        print "current %s: new %s, requiredperms="%(current,new), requiredperms

    if not requiredperms:
       if __debug__:
          print "checkstatusperm: no requiredperms returning"
       # empty permissions, no restriction
       return

    userid = db.getuid()

    if db.security.hasPermission('SetAnyState', userid, cl.classname):
        return

    # note no spaces in required perms
    for perm in [x.strip() for x in requiredperms.split(',')]:
        if db.security.hasPermission(perm, userid, cl.classname):
            return

    # only get here if nothing matched
    raise ValueError, 'You do not have permission to set status to %s'%db.status.get(new,'name')
def init(db):
    db.issue.audit('set', checkstatusperm)
    db.issue.audit('create', checkstatusperm)

