# Copyright (c) 2002 ekit.com Inc (http://www.ekit-inc.com/)
#
# Permission is hereby granted, free of charge, to any person obtaining a copy
# of this software and associated documentation files (the "Software"), to deal
# in the Software without restriction, including without limitation the rights
# to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
# copies of the Software, and to permit persons to whom the Software is
# furnished to do so, subject to the following conditions:
#
#   The above copyright notice and this permission notice shall be included in
#   all copies or substantial portions of the Software.
#
# THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
# IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
# FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
# AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
# LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
# OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
# SOFTWARE.
#
#$Id: autotake.py,v 1.1 2003/03/15 04:25:42 jrouilla Exp $

def autotake(db, cl, nodeid, newvalues):
    ''' If the person sending a message has the Repair role,
        assign them to the issue.
    '''
    if __debug__:
       print "autotake triggered"

    # don't fire if there's no new message
    if not newvalues.has_key('messages'):
        return

    # don't fire if the assignedto property is being set.
    if newvalues.has_key('assignedto'):
        return

    # don't fire if somebody already owns the issue
    if cl.get(nodeid,'assignedto') != None:
        return

    # check to see who is doing the update and if they have
    # the Repair role.
    userid = db.getuid()
    if not db.security.hasPermission('Repair', userid, cl.classname):
        return

    # do the assignment    
    newvalues['assignedto'] = userid

def init(db):
    # fire before changes are made
    db.issue.audit('set', autotake)

# vim: set filetype=python ts=4 sw=4 et si
#SHA: 8b886dd30aaffe232873d1bcdeec179cdaa10aa2
